<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 24/04/2015
 * Time: 09:56
 */

namespace Folha\Logic\ObrigacaoLegal\RAIS;

use \HCM\Util\DateUtil;

abstract class FormataMagnetico
{
    const FORMATO_MAG_NUMERICO = 1;
    const FORMATO_MAG_STRING = 2;
    const FORMATO_MAG_DIA_MES = 3;
    const FORMATO_MAG_DIA_MES_ANO = 4;
    const FORMATO_MAG_DIA_MES_ANO_8D = 5;

    public abstract function getRow();

    /**
     * Transforma formatos em String Magnético
     * @param String|int|float|\DateTime $data
     * @param array $length
     * @return String
     * @throws \Exception
     */
    protected function setData( $data, $length)
    {
        try {
            switch( $length['FORMATO']){
                case(self::FORMATO_MAG_NUMERICO):{
                    $data = (String)$data;
                    $data = substr($data, 0, $length['TAMANHO']);
                    $data = str_pad($data, $length['TAMANHO'], '0', STR_PAD_LEFT);
                    return $data;
                }
                case(self::FORMATO_MAG_STRING):{
                    $data = (String)$data;
                    $data = substr($data, 0, $length['TAMANHO']);
                    $data = str_pad($data, $length['TAMANHO'], ' ', STR_PAD_LEFT);
                    return $data;
                    break;
                }
                case(self::FORMATO_MAG_DIA_MES):{
                    if($data instanceof \DateTime){
                        return $data->format('dm');
                    }elseif(is_string($data)){
                        $data = DateUtil::getDataDeString(substr($data, 0, 10),DateUtil::FORMATO_BRASILEIRO, true);
                        if($data instanceof \DateTime){
                            return $data->format('dm');
                        }
                    }
                    return '0000';
                }
                case(self::FORMATO_MAG_DIA_MES_ANO):{
                    if($data instanceof \DateTime){
                        return $data->format('dmy');
                    }elseif(is_string($data)){
                        $data = DateUtil::getDataDeString(substr($data, 0, 10),DateUtil::FORMATO_BRASILEIRO, true);
                        if($data instanceof \DateTime){
                            return $data->format('dmy');
                        }
                    }
                    return '000000';
                }
                case(self::FORMATO_MAG_DIA_MES_ANO_8D):{
                    if($data instanceof \DateTime){
                        return $data->format('dmY');
                    }elseif(is_string($data)){
                        $data = DateUtil::getDataDeString(substr($data, 0, 10),DateUtil::FORMATO_BRASILEIRO, true);
                        if($data instanceof \DateTime){
                            return $data->format('dmY');
                        }
                    }
                    return '00000000';
                }
            }

            if ($data instanceof \DateTime) {
                switch ($length) {
                    case(4): {
                        return $data->format('dm');
                    }
                    case(6): {
                        return $data->format('dmy');
                    }
                    case(8): {
                        return $data->format('dmY');
                    }
                }
            } elseif (is_numeric($data)) {

            } else {
                $data = (String)$data;
                $data = substr($data, 0, $length);
                $data = str_pad($data, $length, ' ', STR_PAD_RIGHT);
                return $data;
            }
            return null;
        } catch (\Exception $e) {
            throw $e;
        }
    }
} 